+function(window) {
	
	//表单检测
	function isFunction(it) {
        return Object.prototype.toString.call(it) === '[object Function]';
    }
    function isArray(it) {
        return Object.prototype.toString.call(it) === '[object Array]';
    }
	
	//输入提示
	function input_placeholder(input){
		require(["jquery"],function($){
			$(input).each(function(ii,dd){
				var $dd=$(dd),
					placeholder=$dd.attr("data-placeholder"),
					$wrap=$('<span/>').addClass("placeholder-wrap"),
					$tip=$('<span/>').addClass("placeholder-tip");
				$dd.wrap($wrap).parent().append($tip).css({position:"relative"});
				$tip.css({
					position:'absolute',
					left:$dd.css('text-indent')?$dd.css('text-indent'):'0px',
					bottom:'0px',
					top:'0px',
					right:'0px'
				}).html(placeholder);
				$tip.click(function(){
					$dd.focus();
				});
				var cfn=function(){
						if(/^$/.test($dd.val()))$tip.show();
						else $tip.hide();
					};
				$dd.change(cfn).keyup(cfn).keydown(cfn);
				cfn();
			});
		});
	}
	//金额输入
	function input_limit(input){
		require(["jquery"],function($){
			$(input).each(function(ii,dd){
				var $dd=$(dd),
					max=parseInt($dd.attr("data-max"));
				if(isNaN(max))max=0;
				if(max==0){
					$dd.attr("disabled","disabled");
					return ;
				}
				var check=function(){
						max=parseInt($dd.attr("data-max"));
						var val=$(this).val();
						if(val.length>max)$(this).val(val.substr(0,max));
					};
				$dd.keyup(check).change(check);
			});
		});
	}
	function input_money(input){
		require(["jquery"],function($){
			$(input).each(function(ii,dd){
			var $dd=$(dd),
				min=parseFloat($dd.attr("data-min")),
				max=parseFloat($dd.attr("data-max"));
			if(isNaN(min))
				min=0;
			if(isNaN(max))
				max=0;
			if(min==0&&max==0||min==max){
				$dd.val(min);
				$dd.attr("disabled","disabled");
				return ;
			}
			var sval=function(val){
					$(this).val(val.toFixed(2));
				},
				check=function(){
					min=parseFloat($dd.attr("data-min"));
					max=parseFloat($dd.attr("data-max"));
					var val=parseFloat($(this).val());
					if(isNaN(val))
						val=min;
					val=Math.ceil(val*100)/100;
					if($dd.attr("data-max")&&val>=max){
						sval.call(this,max);
					}else if($dd.attr("data-min")&&val<=min){
						sval.call(this,min);
					}else
						sval.call(this,val);
				};
			$dd.keydown(function(e){
				if((e.keyCode>47&&e.keyCode<58)
					||(e.keyCode>95&&e.keyCode<106)
					||e.keyCode==8
					||e.keyCode==9
					||e.keyCode==37
					||e.keyCode==39
					||e.keyCode==46
					||e.keyCode==36
					||e.keyCode==35
					||e.keyCode==190
					||e.keyCode==116
					||e.keyCode==38
					||e.keyCode==40
					||e.keyCode==110
					||e.keyCode==109
					||e.keyCode==173
					)
						return true;
				return false;
			}).blur(check).change(check);
			});
		});
	}
	function input_mail(input){
		require(["jquery","shanliu.mailcomplete"],function($){
			$(input).each(function(ii,dd){
				$(dd).mailcomplete();
				$(dd).keydown(function(e){
					if(e.keyCode==13){//取消默认事件,防止表单提交
						e.preventDefault();
						e.stopPropagation();
					}
				});
			});
		});
	}
	function input_number(input){
		require(["jquery"],function($){
			$(input).each(function(ii,dd){
				var $dd=$(dd),
					min=$dd.attr("data-min"),
					max=$dd.attr("data-max"),
					check=function(){
						min=$dd.attr("data-min");
						max=$dd.attr("data-max");
						var val=parseFloat($(this).val());
						if($dd.attr("data-max")&&val>=max)
							$(this).val(max);
						if($dd.attr("data-min")&&val<=min)
							$(this).val(min);
					};
				$dd.keydown(function(e){
					var self=$(this),
						p=self.attr('data-precision');
					if(typeof p=='undefined'){
						if(e.keyCode==110
						||e.keyCode==190)
							return true;
					}else{
						p=parseInt(p);
						if(p>0){
							if(e.keyCode==110
							||e.keyCode==190){
								if((self.val()+'').indexOf(".")!=-1)
									return false;
								return true;
							}
						}
						if((e.keyCode>47&&e.keyCode<58)
							||(e.keyCode>95&&e.keyCode<106)){
							var val=(self.val()+''),
								ps=val.indexOf('.');
							if(ps!=-1){
								var pv=val.substring(ps+1);
								if(pv.length>=p) return false;
							}
						}
						
					}
					if((e.keyCode>47&&e.keyCode<58)
						||(e.keyCode>95&&e.keyCode<106)
						||e.keyCode==8
						||e.keyCode==9
						||e.keyCode==116
						||e.keyCode==37
						||e.keyCode==39
						||e.keyCode==46
						||e.keyCode==36
						||e.keyCode==35
						||e.keyCode==38
						||e.keyCode==40
						)
						return true;
					return false;
				}).change(check).blur(check);
			});
		});
	}
	function input_datetime(input){
		require(["jquery","jquery.datetimepicker"],function($){
			$(input).each(function(ii,dd){
				var $d=$(dd),
					min_date=$d.attr("data-date-min")||null,
					max_date=$d.attr("data-date-max")||null,
					def_date=$d.attr("data-date-value")||null,
					def_time=$d.attr("data-time-value")||null,
					step=$d.attr("data-step")||30,
					timepicker=true,
					datepicker=true,
					format;
				switch($d.attr('type')){
					case'date':
						timepicker=false;
						format='Y-m-d';
					break;
					case'time':
						datepicker=false;
						format='H:i';
					break;
					default:
						format='Y-m-d H:i:00';
					break;	
				}
				var conf={
					timepicker:timepicker,
					datepicker:datepicker,
					step:step,
					format:format,
					formatDate:'Y-m-d',
					lang:'ch'
				};
				if(min_date){
					conf.minDate=min_date;
				}
				if(max_date)
					conf.maxDate=max_date;
				if(def_date)
					conf.defaultDate=def_date;
				if(def_time)
					conf.defaultTime=def_time;
				$d.datetimepicker(conf);
			});
		});
	}
	function button_val($button,val){
		var t=$button.html();
		if(!t)t='';
		if(typeof val=='undefined'){
			if(!/^\s*$/.test(t))return t;
			return t;
		}
		if(/^\s*$/.test(t)){
			$button.val(val);
		}else $button.html(val);
	}
	function button_is($button){
		return !$button.attr("disabled")&&!$button.hasClass("disabled");
	}
	function button_disable($button,msg,cls){
		var msg=msg||'提交中,请稍后...',
			cls=cls||'disabled';
		if(!button_is($button))return true;
		$button.attr('data-value',button_val($button));
		$button.attr('data-class',cls);
		$button.attr("disabled","disabled")
				.addClass(cls);
		button_val($button,msg);
	}
	function button_enable($button){
		if(button_is($button))return true;
		var cls=$button.attr('data-class');
		button_val($button,$button.attr('data-value'));
		$button.removeAttr('data-class');
		$button.removeAttr('data-value');
		$button.removeAttr("disabled")
		   .removeClass(cls);
	}
	function button_ajax(ajax_callback,$button,msg){
		if(!isFunction(ajax_callback))return;
		if(!button_is($button))return;
		button_disable($button,msg);
		var ajax=ajax_callback(),
			enfn=function(){button_enable($button);};
		if(!ajax||!ajax.then)enfn();
		else ajax.then(enfn).fail(enfn);
		return ajax;
	}
	function button_timeout($button,time,msg,cls){
		var msg=msg||'已发送',
			time=time||60;
		if(!button_is($button))return true;
		button_disable($button,msg+'('+time+')',cls);
		var t=setInterval(function(){
			if(time<=1){
				clearInterval(t);
				button_enable($button);
				return ;
			}
			time--;
			button_val($button,msg+'('+time+')');
		},1000);
	}
	/**
	 * 图片点击重新加载
	 */
	function reimg($img){
		if(!$img||$img.length==0)return ;
		var cls=$img.attr('data-loadclass');
		if($img[0].tagName=='IMG'){
			var src=$img.attr('src');
			var $_img=$img;
			var load=false;
		}else{
			var src=$img.attr('data-src');
			var load=true;
			var $_img=$('<img/>');
			$img.append($_img);
		}
		$img.click(function(){
			cls&&$img.addClass(cls);
			var _src=src.indexOf('?')==-1?(src+'?'):(src+'&');
			$_img.bind('load',function(){
				cls&&$img.removeClass(cls);
			}).attr({
				src:_src+parseInt(Math.random()*100000)
			});
		});
		load&&$img.trigger('click');
	}
	
	
	define( "shanliu.form",['jquery','shanliu.valid','shanliu.validMsg'],function($,valid){
		
		
	    function getValid(_valid) {
	    	for(var i in valid){
	    		if(valid[i]==_valid)return i;
	    	}
	    }
		function formRule(){
			this.rules=[];
		}
		formRule.prototype.rule=function(valid,param){
			if (!param) param = [];
			if(!isFunction(valid))return this;
			this.rules.push({valid:valid,param:param});
			return this;
		}
		function formRuleBind(params,obj){
			var i=0,out=params.slice();
			if(out.length==0)out=[':value'];
			for(;i<out.length;i++){
				switch(out[i]){
					case ':value':
						out[i]=obj?obj.value:'';
					break;
				}
			}
			return out;
		}
		function formItem(name,value,el){
			this.name=name;
			this.value=value;
			this.el=el;
			return this;
		}
		function form(callback){
			this._errors=[];
			this._rules=[];
			this._callback=callback||function(item,msg){
				if(msg)$(item.el).attr({title:msg});
				else $(item.el).removeAttr({title});
			}
		}
		form.prototype.rule=function(item,rule,callback){
			var name,value;
			if(item instanceof $){
				name=item.attr('name')||item.attr('data-name');
				if(!name){
					name=item.attr('id');
					if(!name) name='A'+parseInt(Math.random()*10000);
					item.attr({'data-name':name});
				}
				value=(function(item){
					return function(){
						return item.val();
					};
				})(item);
				item=[name,value,item];
			}
			if(isArray(item)){
				item=formItem.apply({},item);
			}
			if(isArray(rule)){
				var __rule=new formRule(),
					i=0;
				for(;i<rule.length;i++){
					__rule.rule.apply(__rule,rule[i]);
				}
				rule=__rule;
			}
			if(!item.name||!rule.rules||!isFunction(item.value))return this; 
			this._rules[item.name]={
				item:item,rule:rule,callback:callback||this._callback
			};
			return this;
		}
		form.prototype.error=function(name,msg){
			if(name instanceof $){
				name=name.attr('name')||name.attr('data-name');
			}
			if(!name||!msg)return this;
			this._errors.push({name:name,msg:msg});
			return this;
		}
		form.prototype.run=function(name,callback){
			if(name instanceof $){
				name=name.attr('name')||name.attr('data-name');
			}
			if(!this._rules[name])return true;
			var self=this,
				_rule=self._rules[name],
				is_error=function(){
					var i=0;
					for(;i<self._errors.length;i++){
						if(self._errors[i].name==name)return true;
					}
				},
				clr_error=function(){
					var tarr=[],tmp;
					while(tmp=self._errors.shift()){
						if(tmp.name!=name)tarr.push(tmp);
					}
					self._errors=tarr;
				},
				_callback=function(){
					var err=is_error();
					callback&&callback(err);
					if(err){
						var _msg=[],i=0;
						for(;i<self._errors.length;i++){
							if(self._errors[i].name==name)_msg.push(self._errors[i].msg);
						}
						_rule.callback(_rule.item,_msg.join(";"));
					}else _rule.callback(_rule.item,null);
				},
				rule_check=function(rules){
					if(rules.length==0){
						_callback();
						return ;
					}
					var val=_rule.item.value(),
						form_rule=rules.shift(),
						_valid=form_rule.valid,
						param=form_rule.param,
						validname=getValid(_valid);
					if(/^\s*$/.test(val)&&validname!='notEmpty'){
						rule_check(rules);
						return ;
					}
					if(validname){
						var _param=formRuleBind(param,{name:name,value:val});
						_valid=new valid(validname);
						if(!_valid.check.apply(_valid,_param)){
							self.error(_rule.item.name,_valid.message);
							_callback();
						}else{
							rule_check(rules);
						}
					}else{
						var out=_valid.apply(self);
						if(typeof out =='object'&&isFunction(out.then)){
							out.then(function(){
								if(!is_error())rule_check(rules);
								else _callback();
							}).fail(function(obj,type,msg){
								self.error(_rule.item.name,msg);
								_callback();
							});
						}else{
							if(!is_error())rule_check(rules);
							else _callback();
						}
					}
				};
			if(!_rule)return _callback();
			clr_error();
			rule_check(_rule.rule.rules.slice());
		}
		form.prototype.check=function(success,fail){
			var ajax=[],
				self=this,
				callback=function(){
					if(self._errors.length==0){
						var data={};
						for(var k in self._rules){
							data[k]=self._rules[k].item.value();
						}
						success&&success(data);
					}else{
						var error=self._errors,
							_error={},
							_out=[],
							i=0;
						for(;i<error.length;i++){
							if(!_error[error[i].name])_error[error[i].name]=[];
							_error[error[i].name].push(error[i].msg);
						}
						for(i in _error){
							_out.push({el:self._rules[i].item.el,msg:_error[i].join(';')});
						}
						if(fail)fail(_out);
						else _out.shift().el.focus();
					}
				},
				check=0;
			for(var k in self._rules){
				check++;
			}
			self._errors=[];
			for(var k in self._rules){
				self.run(k,function(){
					check--;
					if(check==0)callback();
				});
			}
		}
		
		form.rule=formRule;
		form.item=formItem;
		
		
		//表单辅助函数
		form.input={
			money:input_money,
			datetime:input_datetime,
			number:input_number,
			limit:input_limit,
			placeholder:input_placeholder,
			mail:input_mail
		};
		form.button={
			is:button_is,
			enable:button_enable,
			disable:button_disable,
			timeout:button_timeout,
			ajax:button_ajax
		};
		form.valid={
			reimg:reimg
		};
		//失去焦点且有更改时回调
		$.fn.blurchange=function(callback){
			return this.each(function(i,d){
				var self=$(d),
					pval=null;
				self.blur(function(){
					var val=self.val();
					if(!val)val='';
					if(pval===null||val!=pval){
						pval=val;
						callback&&callback();
					}
				});
				self.change(function(){
					var val=self.val();
					if(val!=pval){
						pval=val;
						callback&&callback();
					}
				});
			});
		}
		
		return form;
	});
}(window);